version: '3'
services:
  nginx:
    image: nginx:alpine
    environment:
      TZ: Asia/Tokyo
    volumes:
      - './docker/nginx/nginx.conf:/etc/nginx/conf.d:ro'
      - './docker/nginx/.htpasswd:/etc/nginx/.htpasswd:ro'
      - '.:/work'
      - './storage/logs/nginx:/var/log/nginx'
    ports:
      - '80:80/tcp'
    depends_on:
      - php
  php:
    build:
      context: ./docker/php
    environment:
      TZ: Asia/Tokyo
    volumes:
      - './docker/php/zzz-php.ini:/usr/local/etc/php/conf.d/zzz-php.ini:ro'
      - '.:/work'
    expose:
      - '9000'
    depends_on:
      - mysql
      - redis
  phpmyadmin:
    image: phpmyadmin/phpmyadmin:latest
    environment:
      PMA_HOST: mysql
      MYSQL_USER: ${DB_USERNAME}
      MYSQL_PASSWORD: ${DB_PASSWORD}
      TZ: Asia/Tokyo
    expose:
      - '80'
    depends_on:
      - mysql
  mysql:
    image: mariadb:latest
    environment:
      MYSQL_RANDOM_ROOT_PASSWORD: "yes"
      MYSQL_DATABASE: ${DB_DATABASE}
      MYSQL_USER: ${DB_USERNAME}
      MYSQL_PASSWORD: ${DB_PASSWORD}
      TZ: Asia/Tokyo
    volumes:
      - './docker/mysql/conf.d/my.cnf:/etc/mysql/conf.d/my.cnf:ro'
      - './docker/mysql/docker-entrypoint-initdb.d:/docker-entrypoint-initdb.d:ro'
      - './storage/data/mysql:/var/lib/mysql'
    expose:
      - '3306'
  echo:
    build:
      context: ./docker/echo
    environment:
      TZ: Asia/Tokyo
    volumes:
      - './docker/echo/laravel-echo-server.json:/work/laravel-echo-server.json:ro'
    expose:
      - '6001'
    depends_on:
      - redis
  redis:
    image: redis:alpine
    environment:
      TZ: Asia/Tokyo
    expose:
      - '6379'
